<?php

namespace Drupal\cck_select_other\Tests;

/**
 * Assert that an empty value is not saved.
 *
 * @group cck_select_other
 */
class CCKSelectOtherEmptyTest extends CCKSelectOtherTestBase {
  /**
   * {@inheritdoc}
   */
  public function setUp() {
    parent::setUp();

    $this->list_options = $this->createOptions();

    $field_info = array(
      'settings' => array(
        'allowed_values' => $this->list_options,
      ),
      'cardinality' => 1,
    );
    $instance_info = array(
      'required' => 0,
    );

    $this->field = $this->createSelectOtherListField('list_string', $field_info, $instance_info);
    $this->assertEqual(count($this->field->getSetting('allowed_values')), 5, 'Found 5 allowed values.');

    $this->field_name = $this->field->getName();
  }

  /**
   * Test field validation for required attribute.
   */
  public function testRequired() {
    // Login as content creator.
    $this->drupalLogin($this->web_user);

    $edit = array(
      'title[0][value]' => $this->randomString(25),
      $this->field_name . '[0][select_other_list]' => 'other',
      $this->field_name . '[0][select_other_text_input]' => '',
    );
    $this->drupalPostForm('node/add/' . $this->contentType->id(), $edit, t('Save'));
    $this->assertNoRaw('<div class="field__item"></div>', 'Field not saved for empty value');

    $edit = array(
      $this->field_name . '[0][select_other_list]' => '_none',
    );
    $this->drupalPostForm('node/1/edit', $edit, t('Save'));
    $this->assertNoRaw('<div class="field__item"></div>', 'Field not saved for empty value');
  }
}
